%{
   /* Pequeno Analisador Lexico de programas Pascal */

#include "y.tab.h"
#include "string.h"

%}

NQUOTE    [^']

%%

"BEGIN"     return(KW_BEGIN);        
"END"       return(KW_END); 
"PROGRAM"   return(KW_PROGRAM); 
"VAR"       return(KW_VAR); 
  
[a-zA-Z]([a-zA-Z0-9\_])*  { 
                            yylval.sval=strdup(yytext);
                            return(IDENTIFIER);
                          };
":="			return(ASSIGNMENT);
":"			return(COLON);
","			return(COMMA);
[0-9]+		{ 
                    yylval.dval=atol(yytext);
                    return(DIGSEQ);
                  }
"."			return(DOT);
"("			return(LPAREN);
"-"			return(MINUS);
"+"			return(PLUS);
[0-9]+"."[0-9]+	{
                    yylval.dval=atol(yytext);
                    return(REALNUMBER);
                  }
")"			return(RPAREN);
";"			return(SEMICOLON);

"(*"[^"*)"]"*)"   |
"{"[^"}"]"}"	;
[ \n\t\f]		;

.			return(ILLEGAL);
