/* Adapted from: http://memphis.compilertools.net/interpreter.html */
/* Adapted by F. Osorio */

%start ROOT

%token EQ
%token NE
%token LT
%token LE
%token GT
%token GE
%token PLUS
%token MINUS
%token MULT
%token DIVIDE
%token RPAREN
%token LPAREN
%token ASSIGN
%token SEMICOLON
%token IF
%token THEN
%token ELSE
%token FI
%token WHILE
%token DO
%token OD
%token PRINT
%token NUMBER
%token NAME

%%

ROOT:
     stmtseq { printf("Executar...\n"); }  // { execute($1); } 
   ;

statement:
     designator ASSIGN expression { printf("Atribuicao\n"); }  // { $$ = assignment($1, $3); } 
   | PRINT expression             { printf("Impressao\n");  }  // { $$ = print($2); } 
   | IF expression THEN stmtseq ELSE stmtseq FI
	                            { printf("Comando IF-THEN-ELSE\n"); }  // { $$ = ifstmt($2, $4, $6); }
   | IF expression THEN stmtseq FI
	                            { printf("Comando IF-THEN\n");      }  // { $$ = ifstmt($2, $4, empty()); }
   | WHILE expression DO stmtseq OD { printf("Comando WHILE\n");      }  // { $$ = whilestmt($2, $4); }   
   ;

stmtseq:
     stmtseq SEMICOLON statement { }
   | statement { }
   ;

expression:
     expr2 { } 
   | expr2 EQ expr2 { }
   | expr2 NE expr2 { }
   | expr2 LT expr2 { }
   | expr2 LE expr2 { }
   | expr2 GT expr2 { }
   | expr2 GE expr2 { }
   ;

expr2:
     expr3 { }
   | expr2 PLUS expr3 { }
   | expr2 MINUS expr3 { }
   ;

expr3:
     expr4 { }
   | expr3 MULT expr4 {}
   | expr3 DIVIDE expr4 { }
   ;
expr4:
     PLUS expr4 { }
   | MINUS expr4 { }
   | LPAREN expression RPAREN { }
   | NUMBER { }
   | designator { }
   ;

designator:
     NAME { }
   ;

%%

#include <stdio.h>

extern FILE *yyin;

main ()
{
  do { yyparse(); }
  while (!feof(yyin));
}


